//
//  MyView.m
//  Ex31
//
//  Created by 川上 博 on 10/04/19.
//  Copyright 2010 徳島大学. All rights reserved.
//

#import "MyView.h"

@implementation MyView
- (id)initWithFrame:(NSRect)frameRect
{
	if ((self = [super initWithFrame:frameRect]) != nil) {
		xm[0]=-3.0; xm[1]=3.0; ym[0]=-3.0; ym[1]=3.0;
		wm[0]=50.0; wm[1]=30.0; hm[0]=50.0; hm[1]=30.0;
		la[0]=0.2; la[1]=0.2; lav[0]=5; lav[1]=5;
		
	}
	return self;
}

- (void)drawRect:(NSRect)rect
{
	NSRect bounds=[self bounds];
	
	double a[2],b[2],c[2],d[2];
	NSBezierPath *bp1;
	
	[[NSColor whiteColor] set];
	[NSBezierPath fillRect:bounds];
	sfactor[0]=(bounds.size.width-wm[0]-wm[1])/(xm[1]-xm[0]);
	sfactor[1]=(bounds.size.height-hm[0]-hm[1])/(ym[1]-ym[0]);
	
	[self drawAxes];
	
	//insert your program here.
	
	a[0]=sfactor[0]*(1.0-xm[0])+wm[0];
	a[1]=sfactor[1]*(1.0-ym[0])+hm[0];
	b[0]=sfactor[0]*(-1.0-xm[0])+wm[0];
	b[1]=sfactor[1]*(1.0-ym[0])+hm[0];
	c[0]=sfactor[0]*(-1.0-xm[0])+wm[0];
	c[1]=sfactor[1]*(-1.0-ym[0])+hm[0];
	d[0]=sfactor[0]*(1.0-xm[0])+wm[0];
	d[1]=sfactor[1]*(-1.0-ym[0])+hm[0];
	
	[[NSColor greenColor] set];
	bp1=[NSBezierPath bezierPath];
	[bp1 setLineWidth:3.0];
	[bp1 moveToPoint:NSMakePoint(a[0], a[1])];
	[bp1 lineToPoint:NSMakePoint(b[0], b[1])];
	[bp1 lineToPoint:NSMakePoint(c[0], c[1])];
	[bp1 lineToPoint:NSMakePoint(d[0], d[1])];
	[bp1 lineToPoint:NSMakePoint(a[0], a[1])];
	[bp1 stroke];
}

- (void)drawAxes
{
	int ticx=5, ticy=5;
	int ix, iy, k, lt0, lt1, lt2;
	double temp, b[2];
    CGFloat pat[2]={3.0,1.5};
	NSRect r;
	NSBezierPath *bp2;
	
	b[0]=sfactor[0]*(xm[1]-xm[0]);
	b[1]=sfactor[1]*(ym[1]-ym[0]);
	
	[[NSColor blueColor] set];	
	bp=[NSBezierPath bezierPath];
	[bp setLineWidth:1.0];
	bp2=[NSBezierPath bezierPath];
	[bp2 setLineWidth:0.3];
	
	//tics and labels for x-axis
	lt0=hm[0];
	lt1=lt0+ticy;
	lt2=lt0+ticy*2;
	temp=xm[0];
	k=0;
	while ((temp- (xm[1]+0.01*la[0]))<=0.0){
		ix=wm[0]+sfactor[0]*(temp-xm[0]);
		if(k%lav[0]==0){
			if(temp<xm[1]-0.1*la[0] && temp>xm[0]+0.1*la[0]){
				[bp moveToPoint:NSMakePoint(ix,lt0)];
				[bp lineToPoint:NSMakePoint(ix,lt2)];
				if(k!=0){
					[bp2 setLineDash:pat count:2 phase:0];
					[bp2 moveToPoint:NSMakePoint(ix,lt2)];
					[bp2 lineToPoint:NSMakePoint(ix, hm[0]+b[1])];
				}
			}
			[self drawMoji:temp xloc:ix yloc:lt0 hvmode:0];
			k=0;
		} else{
			if(temp<xm[1]-0.1*la[0] && temp>xm[0]+0.1*la[0]){
				[bp moveToPoint:NSMakePoint(ix, lt0)];
				[bp lineToPoint:NSMakePoint(ix, lt1)];
			}
		}
		temp +=la[0];
		k++;
	}
	//	[bp stroke];
	
	//tics and labels for y-axis
	lt0=wm[0];
	lt1=lt0+ticx;
	lt2=lt0+ticx*2;
	temp=ym[0];
	k=0;
	while ((temp- (ym[1]+0.01*la[1]))<=0.0){
		iy=hm[0]+sfactor[1]*(temp-ym[0]);
		if(k%lav[1]==0){
			if(temp<ym[1]-0.1*la[1] && temp>ym[0]+0.1*la[1]){
				[bp moveToPoint:NSMakePoint(lt0,iy)];
				[bp lineToPoint:NSMakePoint(lt2,iy)];
				if(k!=0){
					[bp2 setLineDash:pat count:2 phase:0];
					[bp2 moveToPoint:NSMakePoint(lt2,iy)];
					[bp2 lineToPoint:NSMakePoint(wm[0]+b[0],iy)];
				}
			}
			[self drawMoji:temp xloc:lt0 yloc:iy hvmode:1];
			k=0;
		} else{
			if(temp<ym[1]-0.1*la[1] && temp>ym[0]+0.1*la[1]){
				[bp moveToPoint:NSMakePoint(lt0,iy)];
				[bp lineToPoint:NSMakePoint(lt1,iy)];
			}
		}
		temp +=la[1];
		k++;
	}
	[bp stroke];
	
	r=NSMakeRect(wm[0], hm[0], b[0], b[1]);	
	[[NSColor blueColor] set];
	bp=[NSBezierPath bezierPathWithRect:r];
	[bp stroke];
	[bp2 stroke];
}

- (void)drawMoji:(double)num xloc:(double)xpos yloc:(double)ypos hvmode:(int)hv{
	unsigned int strlength;
	NSString *str;
	NSMutableDictionary * attribs=[NSMutableDictionary dictionary];	
	
	[attribs setObject:[NSFont fontWithName:@"Helvetica" size:14]
				forKey:NSFontAttributeName];
	[attribs setObject:[NSColor blueColor]
				forKey:NSForegroundColorAttributeName];
	
    str=[NSString stringWithFormat:@"%.1f", num];  //changed from the earlier version
	strlength=[str length];
	if(hv==0){
		[str drawAtPoint:NSMakePoint(xpos-strlength*4,ypos-24) withAttributes:attribs];	
	}else{
		[str drawAtPoint:NSMakePoint(xpos-strlength*4-14,ypos-8) withAttributes:attribs];
	}
}

@end
